Index: tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF	(revision 516)
+++ tmp/org.txm.concordance.rcp/META-INF/MANIFEST.MF	(revision 517)
@@ -6,7 +6,6 @@
 Bundle-Vendor: Textometrie.org
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Require-Bundle: org.txm.searchengine.core;bundle-version="1.0.0",
- org.txm.annotation.core;bundle-version="1.0.0",
  org.eclipse.core.runtime;bundle-version="3.10.0",
  org.eclipse.ui;bundle-version="3.106.1",
  org.txm.cooccurrence.core;bundle-version="1.0.0";visibility:=reexport,
@@ -19,10 +18,11 @@
  org.txm.rcp,
  org.eclipse.core.expressions;bundle-version="3.4.600",
  org.txm.internalview.core;bundle-version="1.0.0",
- org.txm.internalview.rcp;bundle-version="1.0.0",
- org.txm.annotation.rcp;bundle-version="1.0.0"
-Export-Package: org.txm.concordance.rcp.adapters,
+ org.txm.internalview.rcp;bundle-version="1.0.0"
+Export-Package: org.txm.concordance.rcp.actions,
+ org.txm.concordance.rcp.adapters,
  org.txm.concordance.rcp.editors,
  org.txm.concordance.rcp.handlers,
+ org.txm.concordance.rcp.messages,
  org.txm.concordance.rcp.preferences,
  org.txm.concordance.rcp.widgets
Index: tmp/org.txm.concordance.rcp/schema/org.txm.concordance.rcp.concordanceeditor.extension.exsd
===================================================================
--- tmp/org.txm.concordance.rcp/schema/org.txm.concordance.rcp.concordanceeditor.extension.exsd	(revision 0)
+++ tmp/org.txm.concordance.rcp/schema/org.txm.concordance.rcp.concordanceeditor.extension.exsd	(revision 517)
@@ -0,0 +1,109 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!-- Schema file written by PDE -->
+<schema targetNamespace="org.txm.concordance.rcp" xmlns="http://www.w3.org/2001/XMLSchema">
+<annotation>
+      <appinfo>
+         <meta.schema plugin="org.txm.concordance.rcp" id="org.txm.concordance.rcp.editors.ConcordanceEditorExtension" name="concordance extension"/>
+      </appinfo>
+      <documentation>
+         Supplementary concordance widgets that can be installed after the Concordance editor has set its own widgets
+      </documentation>
+   </annotation>
+
+   <element name="extension">
+      <annotation>
+         <appinfo>
+            <meta.element />
+         </appinfo>
+      </annotation>
+      <complexType>
+         <choice minOccurs="1" maxOccurs="unbounded">
+            <element ref="concextension"/>
+         </choice>
+         <attribute name="point" type="string" use="required">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+            </annotation>
+         </attribute>
+         <attribute name="id" type="string">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+            </annotation>
+         </attribute>
+         <attribute name="name" type="string">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+               <appinfo>
+                  <meta.attribute translatable="true"/>
+               </appinfo>
+            </annotation>
+         </attribute>
+      </complexType>
+   </element>
+
+   <element name="concextension">
+      <complexType>
+         <attribute name="class" type="string">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+               <appinfo>
+                  <meta.attribute kind="java" basedOn="org.txm.concordance.rcp.editors.ConcordanceEditorExtension:"/>
+               </appinfo>
+            </annotation>
+         </attribute>
+         <attribute name="name" type="string">
+            <annotation>
+               <documentation>
+                  The extension name
+               </documentation>
+            </annotation>
+         </attribute>
+      </complexType>
+   </element>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="since"/>
+      </appinfo>
+      <documentation>
+         [Enter the first release in which this extension point appears.]
+      </documentation>
+   </annotation>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="examples"/>
+      </appinfo>
+      <documentation>
+         [Enter extension point usage example here.]
+      </documentation>
+   </annotation>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="apiinfo"/>
+      </appinfo>
+      <documentation>
+         [Enter API information here.]
+      </documentation>
+   </annotation>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="implementation"/>
+      </appinfo>
+      <documentation>
+         [Enter information about supplied implementation of this extension point.]
+      </documentation>
+   </annotation>
+
+
+</schema>

Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/widgets/ComplexSortSelector.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/widgets/ComplexSortSelector.java	(revision 516)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/widgets/ComplexSortSelector.java	(revision 517)
@@ -228,6 +228,6 @@
 		fourthKey.select(0);
 		editor.getUserDefinedComparators().add(defaultComparator);
 		editor.setCurrentComparator(defaultComparator);
-		editor.sort();
+//		editor.sort(); // do it later 
 	}
 }
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditorExtension.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditorExtension.java	(revision 0)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditorExtension.java	(revision 517)
@@ -0,0 +1,51 @@
+package org.txm.concordance.rcp.editors;
+
+
+
+/**
+ * Extension point class to add a stuff to the concordance editor.
+ * 
+ * All widgets creation are done after the editor widgets creation
+ * 
+ * @author mdecorde
+ *
+ */
+public abstract class ConcordanceEditorExtension {
+	
+	public static final String EXTENSION_ID = ConcordanceEditorExtension.class.getName();
+	protected ConcordanceEditor editor;
+	
+	public ConcordanceEditorExtension() {
+		
+	}
+
+	/**
+	 * 
+	 * @return the column name displayed in the concordance table widget
+	 */
+	public abstract String getName();
+	
+	/**
+	 * implement this command to add widgets to the concordance interface using the 2 available area : editor.getQueryArea() and editor.getDisplayArea()
+	 * @return
+	 */
+	public abstract boolean installWidgets() throws Exception;
+	
+	/**
+	 * implement this command to do something when the EditorPart.init(IEditorSite site, IEditorInput input) is called
+	 * @return
+	 */
+	public abstract boolean initialiseInput(ConcordanceEditor editor) throws Exception;
+	
+	/**
+	 * implement this command to do set something before computing the result
+	 * @return
+	 */
+	public abstract boolean notifyStartOfCompute() throws Exception;
+	
+	/**
+	 * implement this command to do set something after computing the result
+	 * @return
+	 */
+	public abstract boolean notifyEndOfCompute() throws Exception;
+}

Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 516)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 517)
@@ -25,19 +25,19 @@
 //
 package org.txm.concordance.rcp.editors;
 
-import java.io.File;
 import java.util.ArrayList;
-import java.util.HashMap;
+import java.util.Arrays;
+import java.util.HashSet;
 import java.util.Iterator;
 import java.util.List;
-import java.util.Vector;
-import java.util.logging.Level;
 
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.ISafeRunnable;
 import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Platform;
+import org.eclipse.core.runtime.SafeRunner;
 import org.eclipse.core.runtime.Status;
 import org.eclipse.e4.ui.workbench.modeling.EModelService;
 import org.eclipse.jface.action.Action;
@@ -45,16 +45,10 @@
 import org.eclipse.jface.action.IMenuManager;
 import org.eclipse.jface.action.MenuManager;
 import org.eclipse.jface.action.Separator;
-import org.eclipse.jface.dialogs.InputDialog;
-import org.eclipse.jface.dialogs.MessageDialog;
-import org.eclipse.jface.viewers.ArrayContentProvider;
-import org.eclipse.jface.viewers.ComboViewer;
-import org.eclipse.jface.viewers.ISelection;
-import org.eclipse.jface.viewers.ISelectionChangedListener;
-import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.jface.viewers.SelectionChangedEvent;
+import org.eclipse.jface.viewers.ColumnLabelProvider;
 import org.eclipse.jface.viewers.StructuredSelection;
 import org.eclipse.jface.viewers.TableViewer;
+import org.eclipse.jface.viewers.TableViewerColumn;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.browser.ProgressListener;
@@ -79,7 +73,6 @@
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.layout.GridLayout;
 import org.eclipse.swt.widgets.Button;
-import org.eclipse.swt.widgets.Combo;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Event;
@@ -90,28 +83,12 @@
 import org.eclipse.swt.widgets.ScrollBar;
 import org.eclipse.swt.widgets.Table;
 import org.eclipse.swt.widgets.TableColumn;
-import org.eclipse.swt.widgets.Text;
+import org.eclipse.swt.widgets.TableItem;
 import org.eclipse.ui.IEditorInput;
 import org.eclipse.ui.IEditorSite;
 import org.eclipse.ui.IWorkbenchPage;
 import org.eclipse.ui.IWorkbenchPartSite;
-import org.eclipse.ui.IWorkbenchWindow;
 import org.eclipse.ui.PartInitException;
-import org.eclipse.ui.dialogs.ListDialog;
-import org.txm.annotation.core.Annotation;
-import org.txm.annotation.core.AnnotationManager;
-import org.txm.annotation.core.KRAnnotationEngine;
-import org.txm.annotation.core.preferences.AnnotationPreferences;
-import org.txm.annotation.core.repository.AnnotationType;
-import org.txm.annotation.core.repository.KnowledgeRepository;
-import org.txm.annotation.core.repository.KnowledgeRepositoryManager;
-import org.txm.annotation.core.repository.LocalKnowledgeRepository;
-import org.txm.annotation.core.repository.SQLKnowledgeRepository;
-import org.txm.annotation.core.repository.TypedValue;
-import org.txm.annotation.rcp.commands.InitializeKnowledgeRepository;
-import org.txm.annotation.rcp.commands.SaveAnnotations;
-import org.txm.annotation.rcp.commands.krview.OpenKRView;
-import org.txm.annotation.rcp.views.knowledgerepositories.KRView;
 import org.txm.concordance.core.functions.Concordance;
 import org.txm.concordance.core.functions.Line;
 import org.txm.concordance.core.functions.comparators.CompositeComparator;
@@ -145,15 +122,12 @@
 import org.txm.rcp.RCPMessages;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.TXMWindows;
-import org.txm.rcp.commands.OpenBrowser;
 import org.txm.rcp.editors.TXMBrowser;
 import org.txm.rcp.editors.TXMEditorPart;
 import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.editors.TableKeyListener;
 import org.txm.rcp.preferences.RCPPreferences;
-import org.txm.rcp.swt.dialog.ConfirmDialog;
 import org.txm.rcp.swt.dialog.ViewPropertySelectionDialog;
-import org.txm.rcp.swt.provider.SimpleLabelProvider;
 import org.txm.rcp.swt.widget.AssistedQueryWidget;
 import org.txm.rcp.swt.widget.NavigationWidget;
 import org.txm.rcp.utils.JobHandler;
@@ -166,9 +140,7 @@
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
-import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.corpus.query.Query;
-import org.txm.utils.AsciiUtils;
 import org.txm.utils.logger.Log;
 
 /**
@@ -180,11 +152,6 @@
 
 	public static final String ID = ConcordanceEditor.class.getName();
 
-	/**
-	 * the limit number of annotation when a confirm dialog box is shown
-	 */
-	private static final int NALERTAFFECTANNOTATIONS = 100;
-
 	String locale = TXMPreferences.getString(RCPPreferences.UI_LOCALE, RCPPreferences.PREFERENCES_NODE);
 
 	/** The lineids. */
@@ -230,11 +197,7 @@
 	/** The concordance. */
 	private Concordance concordance;
 
-	/** The annotation service */
-	private AnnotationManager  annotManager;
 
-	//boolean annotation_expert_mode = TxmPreferences.getBoolean(AnnotationPreferencePage.MODE, false);
-
 	/** The standard comparator class name. */
 	private LineComparator[] standardComparatorClassName = {
 			new NullComparator(), new LexicographicKeywordComparator(),
@@ -324,31 +287,20 @@
 	/** The query area. */
 	private Composite queryArea;
 
-	/** The annotation area. */
-	private Composite annotationArea;
-
 	/** The navigation area. */
-	private NavigationWidget navigationArea;
+	private NavigationWidget navigationWidget;
 
 	/** The is setup shown. */
 	private boolean isSetupShown = true;
 
-
-	/** The hide btn. */
+	/** The hide btn: hides the form
+	 * TODO: remove the button when the TXMEditorToolbar is fully functionnal. */
 	private Button hideBtn;
 	private Button deleteLineButton;
 
 	/** The query size. */
 	protected Point querySize;
 
-	protected Point annotationSize;
-
-	/** The annot btn. */
-	private Button annotationButton;
-
-	private Text annotationValuesText;
-	private ComboViewer annotationTypesCombo;
-
 	/** The parent. */
 	private Composite parent;
 
@@ -356,19 +308,9 @@
 
 	private ArrayList<Property> availableRightSortProperties;
 
-	private List<TypedValue> typeValuesList;
-
-	protected Point annotSize;
-
-	private TableColumn annotationColumn;
-
-	private Combo addRemoveCombo;
-	private Combo affectCombo;
-	private Button affectAnnotationButton;
-
-	private Button infosAnnotTypeSelectedLink;
-
 	private Sash sash;
+	
+	HashSet<ConcordanceEditorExtension> extensions = new HashSet<ConcordanceEditorExtension>();
 
 	/* (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#doSave(org.eclipse.core.runtime.IProgressMonitor)
@@ -414,8 +356,41 @@
 			throws PartInitException {
 		setSite(site);
 		setInput(input);
-
+		
 		initializeEditor();
+		
+		// fetch extensions
+		IConfigurationElement[] config = Platform.getExtensionRegistry()
+				.getConfigurationElementsFor(ConcordanceEditorExtension.EXTENSION_ID);
+		Log.warning("Installing ConcordanceEditorExtension...");
+		Log.warning(Arrays.toString(config));
+		
+		for (IConfigurationElement e : config) {
+			try {
+				Log.warning(" "+e.getName()+" from "+e.getContributor().getName());
+				final Object o = e.createExecutableExtension("class"); //$NON-NLS-1$
+				if (o instanceof ConcordanceEditorExtension) {
+					ISafeRunnable runnable = new ISafeRunnable() {
+
+						@Override
+						public void handleException(Throwable exception) {
+							System.out.println("Error while installing: "+o+": "+ exception.getLocalizedMessage());
+						}
+
+						@Override
+						public void run() throws Exception {
+							ConcordanceEditorExtension ext = ((ConcordanceEditorExtension) o);
+							if (ext.initialiseInput(ConcordanceEditor.this)) {
+								extensions.add(ext);
+							}
+						}
+					};
+					SafeRunner.run(runnable);
+				}
+			} catch (Exception ex) {
+				System.out.println("Exception while installing "+e.getName()+": "+ex.getLocalizedMessage());
+			}
+		}
 	}
 
 	private void initializeEditor() throws PartInitException {
@@ -427,7 +402,6 @@
 		}
 		this.concordance = (Concordance)result;
 		this.corpus = concordance.getCorpus();
-		this.annotManager = KRAnnotationEngine.getAnnotationManager(corpus);
 
 		this.standardComparators = new ArrayList<LineComparator>();
 		this.userDefinedComparators = new ArrayList<LineComparator>();
@@ -484,12 +458,41 @@
 		try {
 			composeControlArea(controlArea);
 			composeDisplayArea(getDisplayArea());
+			composeExtraAreas(controlArea, getDisplayArea());
+			// finally set the sorter to fill the tables
+			if (complexsorter != null) {
+				complexsorter.setComparators(this);
+			}
+			
+			fillDisplayArea(topLine, bottomLine); // init columns and show first results if any
+			resetColumnWidths();
+			
 		} catch(Exception e) {
 			System.out.println("Error while building interface: "+e.getLocalizedMessage());
 			Log.printStackTrace(e);
 		}
 	}
 
+	private void composeExtraAreas(Composite controlArea, Composite displayArea) {
+		
+		for (final ConcordanceEditorExtension ext : extensions) {
+			ISafeRunnable runnable = new ISafeRunnable() {
+				@Override
+				public void handleException(Throwable exception) {
+					System.out.println("Error while installing: "+ext+": "+ exception.getLocalizedMessage());
+				}
+
+				@Override
+				public void run() throws Exception {
+					if (!ext.installWidgets()) {
+						extensions.remove(ext);
+					}
+				}
+			};
+			SafeRunner.run(runnable);
+		}
+	}
+
 	/**
 	 * Compose display area.
 	 *
@@ -504,20 +507,16 @@
 		viewer2.setLabelProvider(new LineLabelProvider(this) {
 			@Override
 			public String getColumnText(Object element, int columnIndex) {
-				if (columnIndex == 1) {
 					Line line = (Line) element;
 					return line.getViewRef().toString();
-				} else {
-					return "";
-				}
 			}
 		});
 		viewer2.setContentProvider(new ConcordancesProvider());
 		viewer2.getTable().setLinesVisible(true);
 		viewer2.getTable().setHeaderVisible(true);
 
-		firstColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
-		firstColumn.setWidth(0);
+//		firstColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
+//		firstColumn.setWidth(10);
 
 		referenceColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
 		refreshReferenceColumnTitle();
@@ -549,10 +548,7 @@
 			}
 		});
 		referenceColumn.setWidth(100);
-		
-		firstColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
-		firstColumn.setWidth(0);
-		
+				
 		sash = new Sash(displayArea, SWT.VERTICAL);
 		sash.addSelectionListener(new SelectionAdapter() {
 		      public void widgetSelected(SelectionEvent event) {
@@ -562,7 +558,7 @@
 		    });
 		viewer = new TableViewer(displayArea, SWT.MULTI | SWT.FULL_SELECTION | SWT.BORDER | SWT.VIRTUAL);
 		viewer.getTable().addKeyListener(new TableKeyListener(viewer));
-		viewer.setLabelProvider(new LineLabelProvider(this));
+		//viewer.setLabelProvider(new LineLabelProvider(this));
 		viewer.setContentProvider(new ConcordancesProvider());
 		viewer.getTable().setLinesVisible(true);
 		viewer.getTable().setHeaderVisible(true);
@@ -575,6 +571,7 @@
 			viewer2.getTable().setFont(font);
 		}
 
+		// try to center on keyword column
 		viewer.getTable().addListener(SWT.Resize, new Listener() {
 			@Override
 			public void handleEvent(Event event) {
@@ -603,13 +600,22 @@
 		viewer.getTable().addKeyListener(kldelete);
 		viewer2.getTable().addKeyListener(kldelete);
 
-		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
-		firstColumn.setWidth(0);
+//		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+//		firstColumn.setWidth(0);
+//		firstColumn.setResizable(false);
 
-		leftContextColumn = new TableColumn(viewer.getTable(), SWT.RIGHT);
+		TableViewerColumn leftColumnViewer = new TableViewerColumn(viewer, SWT.RIGHT);
+		leftContextColumn = leftColumnViewer.getColumn();
 		leftContextColumn.setText(Messages.ConcordancesEditor_2);
 		leftContextColumn.setToolTipText(Messages.ConcordancesEditor_2);
 		leftContextColumn.setAlignment(SWT.RIGHT);
+		leftColumnViewer.setLabelProvider(new ColumnLabelProvider() {
+			@Override
+			public String getText(Object element) {
+				Line line = (Line) element;
+				return line.leftContextToString();
+			}
+		});
 		leftContextColumn.addSelectionListener(new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent e) {
@@ -635,10 +641,18 @@
 			}
 		});
 
-		keywordColumn = new TableColumn(viewer.getTable(), SWT.CENTER);
+		TableViewerColumn keywordColumnViewer = new TableViewerColumn(viewer, SWT.CENTER);
+		keywordColumn = keywordColumnViewer.getColumn();
 		keywordColumn.setText(Messages.ConcordancesEditor_3);
 		keywordColumn.setToolTipText(Messages.ConcordancesEditor_3);
 		keywordColumn.setAlignment(SWT.CENTER);
+		keywordColumnViewer.setLabelProvider(new ColumnLabelProvider() {
+			@Override
+			public String getText(Object element) {
+				Line line = (Line) element;
+				return line.keywordToString();
+			}
+		});
 		keywordColumn.addSelectionListener(new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent e) {
@@ -664,15 +678,19 @@
 			}
 		});
 
-		annotationColumn = new TableColumn(viewer.getTable(), SWT.CENTER);
-		annotationColumn.setText(Messages.ConcordancesEditor_15);
-		annotationColumn.setToolTipText(Messages.ConcordancesEditor_17);
-		annotationColumn.setAlignment(SWT.CENTER);
-
-		rightContextColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+		
+		TableViewerColumn rightContextColumnViewer = new TableViewerColumn(viewer, SWT.LEFT);
+		rightContextColumn = rightContextColumnViewer.getColumn();
 		rightContextColumn.setText(Messages.ConcordancesEditor_4);
 		rightContextColumn.setToolTipText(Messages.ConcordancesEditor_4);
 		rightContextColumn.setAlignment(SWT.LEFT);
+		rightContextColumnViewer.setLabelProvider(new ColumnLabelProvider() {
+			@Override
+			public String getText(Object element) {
+				Line line = (Line) element;
+				return line.rightContextToString();
+			}
+		});
 		rightContextColumn.addSelectionListener(new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent e) {
@@ -699,28 +717,36 @@
 			}
 		});
 
-		resetColumnWidths(); // set column widths
+//		firstColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+//		firstColumn.setWidth(0);
+//		firstColumn.setResizable(false);
+		
+		leftContextColumn.setWidth(200);
+		keywordColumn.setWidth(100);
+		rightContextColumn.setWidth(200);
+		
+		//resetColumnWidths(); // set column widths
 
 		createContextMenu();
 
-		// And now, a sweet piece of code :)
-		// When the window is resized, the scrollbar is adjusted so that the
-		// keywords remain centered
-		viewer.getTable().addListener(SWT.Resize, new Listener() {
-			@Override
-			public void handleEvent(Event event) {
-				ScrollBar bar = viewer.getTable().getHorizontalBar();
-				//float l = leftContextColumn.getWidth();
-				//float k = keywordColumn.getWidth();
-				rightContextColumn.getWidth();
-				//float t = lineTableViewer.getTable().getClientArea().width;
-				bar.getMaximum();
-				bar.getThumb();
-			}
-		});
+//		// And now, a sweet piece of code :)
+//		// When the window is resized, the scrollbar is adjusted so that the
+//		// keywords remain centered
+//		viewer.getTable().addListener(SWT.Resize, new Listener() {
+//			@Override
+//			public void handleEvent(Event event) {
+//				ScrollBar bar = viewer.getTable().getHorizontalBar();
+//				//float l = leftContextColumn.getWidth();
+//				//float k = keywordColumn.getWidth();
+//				rightContextColumn.getWidth();
+//				//float t = lineTableViewer.getTable().getClientArea().width;
+//				bar.getMaximum();
+//				bar.getThumb();
+//			}
+//		});
 
 		// back to text mouse listener
-		viewer.getTable().addMouseListener(new MouseListener() {
+		MouseListener ms = new MouseListener() {
 			@Override
 			public void mouseDoubleClick(MouseEvent e) {
 				StatusLine.setMessage(Messages.ConcordancesEditor_50);
@@ -732,8 +758,10 @@
 			public void mouseDown(MouseEvent e) { }
 			@Override
 			public void mouseUp(MouseEvent e) {	}
-		});
-
+		};
+		viewer.getTable().addMouseListener(ms);
+		viewer2.getTable().addMouseListener(ms);
+		
 		// On Windows, the selection is gray if the table does not have focus.
 		// To make both tables appear in focus, draw the selection background
 		// here.
@@ -756,52 +784,11 @@
 		};
 
 		// Listeners to avoid 0 width columns
-		referenceColumn.addControlListener(new ControlListener() {
-			@Override
-			public void controlMoved(ControlEvent e) { }
-			@Override
-			public void controlResized(ControlEvent e) {
-				if (referenceColumn.getWidth() < 5) referenceColumn.setWidth(5);
+		referenceColumn.addControlListener(new ConcordanceColumnSizeControlListener(referenceColumn));
+		leftContextColumn.addControlListener(new ConcordanceColumnSizeControlListener(leftContextColumn));
+		keywordColumn.addControlListener(new ConcordanceColumnSizeControlListener(keywordColumn));
+		rightContextColumn.addControlListener(new ConcordanceColumnSizeControlListener(rightContextColumn));
 
-			}
-		});
-		leftContextColumn.addControlListener(new ControlListener() {
-			@Override
-			public void controlMoved(ControlEvent e) { }
-			@Override
-			public void controlResized(ControlEvent e) {
-				if (leftContextColumn.getWidth() < 5) leftContextColumn.setWidth(5);
-
-			}
-		});
-		keywordColumn.addControlListener(new ControlListener() {
-			@Override
-			public void controlMoved(ControlEvent e) { }
-			@Override
-			public void controlResized(ControlEvent e) {
-				if (keywordColumn.getWidth() < 5) keywordColumn.setWidth(5);
-
-			}
-		});
-		annotationColumn.addControlListener(new ControlListener() {
-			@Override
-			public void controlMoved(ControlEvent e) { }
-			@Override
-			public void controlResized(ControlEvent e) {
-				if (annotationArea != null && annotationColumn.getWidth() < 5) annotationColumn.setWidth(5);
-
-			}
-		});
-		rightContextColumn.addControlListener(new ControlListener() {
-			@Override
-			public void controlMoved(ControlEvent e) { }
-			@Override
-			public void controlResized(ControlEvent e) {
-				if (rightContextColumn.getWidth() < 5) rightContextColumn.setWidth(5);
-
-			}
-		});
-
 		viewer.getTable().addListener(SWT.EraseItem, eraseListener);
 		
 		leftTable = viewer2.getTable();
@@ -944,27 +931,19 @@
 
 		viewer.setInput(lines);
 		viewer2.setInput(lines);
-//		referenceColumn.pack();
-		leftContextColumn.pack();
-		keywordColumn.pack();
-		rightContextColumn.pack();
-		viewer.getTable().pack(true);
-		viewer.getTable().getParent().layout();
-//		viewer2.getTable().pack(true);
-		viewer2.getTable().getParent().layout();
 
 		topLine = from;
 		bottomLine = to;
 
-		navigationArea.setInfoLineText(""+(from + 1), //$NON-NLS-1$
+		navigationWidget.setInfoLineText(""+(from + 1), //$NON-NLS-1$
 				" - "+(to + 1) + " / " + concordance.getNLines()); //$NON-NLS-1$ //$NON-NLS-2$
 
-		navigationArea.setPreviousEnabled(topLine > 0);
-		navigationArea.setFirstEnabled(topLine > 0);
-		navigationArea.setNextEnabled(bottomLine < concordance.getNLines() - 1);
-		navigationArea.setLastEnabled(bottomLine < concordance.getNLines() - 1);
-		navigationArea.layout();
-		navigationArea.getParent().layout();
+		navigationWidget.setPreviousEnabled(topLine > 0);
+		navigationWidget.setFirstEnabled(topLine > 0);
+		navigationWidget.setNextEnabled(bottomLine < concordance.getNLines() - 1);
+		navigationWidget.setLastEnabled(bottomLine < concordance.getNLines() - 1);
+		navigationWidget.layout();
+		navigationWidget.getParent().layout();
 
 		refreshReferenceColumnTitle();
 
@@ -972,22 +951,7 @@
 		viewer2.getControl().setRedraw(true);
 	}
 
-	HashMap<AnnotationType, ArrayList<TypedValue>> history = new HashMap<AnnotationType, ArrayList<TypedValue>>();
 
-	private Button addAnnotationTypeLink;
-
-	private KnowledgeRepository currentKnowledgeRepository = null;
-	Vector<AnnotationType> typesList = new Vector<AnnotationType>(); 
-
-	private Button addTypedValueLink;
-
-	private Label withLabel;
-
-	private AnnotationType tagAnnotationType; // the tag annotation type if annotation mode is simple
-
-	private Label equalLabel;
-	Boolean advanced_annotation_mode = false;
-
 	private Table leftTable;
 
 	private Table rightTable;
